unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, TxRx, Math, ExtCtrls, Buttons, Menus, OleServer,
  ExcelXP;

type
  TForm1 = class(TForm)
    ComboBox1: TComboBox;
    Button1: TButton;
    Edit1: TEdit;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    Timer1: TTimer;
    Memo1: TMemo;
    ScrollBar1: TScrollBar;
    Memo3: TMemo;
    Memo2: TMemo;
    Memo4: TMemo;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    Memo5: TMemo;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    N7: TMenuItem;
    N10: TMenuItem;
    N11: TMenuItem;
    procedure ComboBox1Change(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TxRxrmCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure N9Click(Sender: TObject);
    procedure N8Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure N11Click(Sender: TObject);
    procedure N10Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Stop:Boolean;
  da1: Array[1..12,0..7]of Boolean;
  fb1: Array[1..13]of Boolean;
  data: Array[1..2000,1..10] of Byte;
  data2:Array[1..2000,1..13] of Boolean;
  flagi1:Array[1..2000,0..7]of Boolean;
  flagi2:Array[1..2000,0..7]of Boolean;
  TimeN:Array[1..2000]of TDateTime;
  Nechto:Array[1..2000]of Boolean;
  Kadr:Integer;
  Fors:Integer;
  Davl:Boolean;

implementation

uses Unit2,Unit3,Unit4;

{$R *.dfm}

procedure TForm1.ComboBox1Change(Sender: TObject);
var
port: String;
begin
  port:=Form1.ComboBox1.Text;
  PurgeCOM;
  CloseCOM;
  if OpenCOM(pchar(port)) then
   begin
    SetCOMTo(MAXDWORD,0,0,0,0);
    SetModCOM(57600,8,NOPARITY,oneSTOPBIT,FALSE,FALSE);
   end
  else
   begin
    Application.MessageBox(pchar(port),'',MB_OK or MB_IconError);
    Exit;
   end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Stop:=True;
  PurgeCOM;
  CloseCOM;
end;

function Res(i:Byte):Byte;
var
n,x:Integer;
begin
x:=0;
for n:=0 to 7 do
  if da1[i,n] then x:=x + 1 shl(n);
Result:=x;
end; 

function FileNam(s:String):String;
var
n,i:Integer;
a,x:String;
begin
  n:=StrLen(pchar(s));
  a:='';
  for i:=0 to n do
    begin
    if s[n-i]='\' then break;
    a:=a+s[n-i];
    end;
    n:=StrLen(pchar(a));
    x:='';
    for i:=0 to n do x:=x+a[n-i];
    Result:=x;
end;

procedure MemoDraw(k:Integer);
var
i:Integer;
v:Extended;
dan1:Array[1..25]of String;
dan2:Array[1..25]of String;                              
begin
  for i:=1 to 25 do
    Dan1[i]:='';
  for i:=1 to 25 do
    dan2[i]:='';
  Dan1[1]:=':';
  for i:= 2 to 13 do
    if data2[k,i] then Dan2[1]:=Dan2[1]+'1'
      else Dan2[1]:=Dan2[1]+'0';

  dan1[2]:='1.  :';
  dan1[3]:='2.  :';
  dan1[4]:='3.   :';
  dan1[5]:='4.   .:';
  dan1[6]:='5.   :';
  dan1[7]:='6.   :';
  dan1[8]:='7.  .:';
  dan1[9]:='8.  :';
  dan1[10]:='9.   :';
  dan1[11]:='10.   :';
  dan1[12]:='11.0  ...:';
  dan1[13]:='11.1   .:';
  dan1[14]:='11.4  :';
  dan1[15]:='11.5  / :';
  dan1[16]:='11.6  . :';
  dan1[17]:='12.0  :';
  dan1[18]:='12.1   .:';
  dan1[19]:='12.2  :';
  dan1[20]:='12.3  :';
  dan1[21]:='12.4   :';
  dan1[22]:='12.5   :';
  dan1[23]:='12.7  :';
  dan1[24]:='/:';
  dan1[25]:=':';

  dan2[2]:= FloatToStrF(data[k,1]/10,ffFixed,3,1)+' .';
  Dan2[3]:= FloatToStrF(data[k,2]/4-10,ffFixed,3,1)+' .';
  Dan2[4]:= FloatToStrF(data[k,3],ffFixed,3,0)+' ';
  Dan2[5]:= FloatToStrF(data[k,4]*25,ffFixed,4,0)+' /';
  if Davl=False then Dan2[6]:= FloatToStrF(data[k,5]/1.5,ffFixed,3,1)+' kPa'
    else Dan2[6]:= FloatToStrF(data[k,5]*5,ffFixed,3,0)+' ...';
  i:=data[k,6];
case i of
  0..15:V:=-40;
  16..36:V:=0.95*i-54.3;
  37..80:V:=0.455*i-36.4;
  81..133:V:=0.377*i-30.2;
  134..182:V:=0.408*i-34.3;
  183..209:V:=0.741*i-94.8;
  210..227:V:=1.111*i-172.2;
  228..238:V:=1.818*i-332.7;
  239..245:V:=2.857*i-580;
  246..255:V:=120;
end;
  Dan2[7]:= FloatToStrF(V,ffFixed,3,1)+' .';
  Dan2[8]:= FloatToStrF(data[k,7]/2,ffFixed,3,1)+' .';
  Dan2[9]:= FloatToStrF(data[k,8],ffFixed,3,0)+' /';
  Dan2[10]:= FloatToStrF(data[k,9]*5/256,ffFixed,3,2)+'';
  Dan2[11]:= FloatToStrF(data[k,10]*5/256,ffFixed,3,2)+'';
  if flagi1[k,0] then Dan2[12]:=''      //11.0 -  
    else Dan2[12]:='';
  if flagi1[k,1] then Dan2[13]:=''       //11.1 -  
    else Dan2[13]:='';
  if flagi1[k,4] then Dan2[14]:=''        //11.4 - 
    else Dan2[14]:='';
  if flagi1[k,5] then Dan2[15]:=''      //11.5 - A/F control
    else Dan2[15]:='';
  if flagi1[k,6] then Dan2[16]:=''     //11.6 - A/F control
    else Dan2[16]:='';

  if flagi2[k,0] then Dan2[17]:=''             //12.0 - 
    else Dan2[17]:='';
  if flagi2[k,1] then Dan2[18]:=''       //12.1 -  
    else Dan2[18]:='';
  if flagi2[k,2] then Dan2[20]:=''          //12.2 - 
    else Dan2[20]:='';
  if flagi2[k,3] then Dan2[19]:=''          //12.3 -   
    else Dan2[19]:='';
  if flagi2[k,4] then Dan2[21]:=''       //12.4 -  
    else Dan2[21]:='';
  if flagi2[k,5] then Dan2[22]:=''       //12.4 -  
    else Dan2[22]:='';
  if flagi2[k,7] then                                         //12.7 -    ????
    Dan2[23]:=''
  else
    Dan2[23]:='';
  Dan2[24]:=IntToStr(k)+' / '+IntToStr(Form1.ScrollBar1.Max);
  Dan2[25]:=TimeToStr(TimeN[k]);


Form1.Memo1.Clear;
Form1.Memo2.Clear;
for i:=1 to 25 do
  begin
  Form1.Memo1.Lines.Add(Dan1[i]);
  end;
for i:=1 to 25 do
  begin
  Form1.Memo2.Lines.Add(Dan2[i]);
  end;
end;

procedure Load;
var
  F: TextFile;
  s:String;
  i,n:Integer;
begin
  Stop:=True;
  for n:=1 to 2000 do
    for i:=1 to 26 do
      Data[n,i]:=0;
  if Form1.OpenDialog1.Execute then
  begin
    AssignFile(F, Form1.OpenDialog1.FileName);
    Reset(F);
    Readln(F, s);
    if (s='File for CarTester 1.0.0.1')or(s='File for CarTester 1.0.0.2') then
      begin
      Readln(F, s);
      Kadr:=StrToInt(s);
      for n:=1 to Kadr do
        begin
        for i:=1 to 10 do
          begin
          Readln(F, s);
          Data[n,i]:=StrToInt(s);
          end;
        for i:=1 to 13 do
          begin
          Readln(F, s);
          if s='1' then Data2[n,i]:=True
            else Data2[n,i]:=False;
          end;
        for i:=0 to 7 do
          begin
          Readln(F, s);
          if s='1' then Flagi1[n,i]:=True
            else Flagi1[n,i]:=False;
          end;
        for i:=0 to 7 do
          begin
          Readln(F, s);
          if s='1' then Flagi2[n,i]:=True
            else Flagi2[n,i]:=False;
          end;
        Readln(F, s);
        if s='1' then Nechto[n]:=True
          else Nechto[n]:=False;
        Readln(F, s);
        TimeN[n] :=StrToTime(s);
        end;
      Form1.Memo3.Clear;
      Form1.Memo4.Clear;
      Form1.Memo5.Clear;
      for i:=1 to 25 do
        begin
        Readln(F, s);
        Form1.Memo3.Lines.Add(s);
        Readln(F, s);
        Form1.Memo4.Lines.Add(s);
        Readln(F, s);
        Form1.Memo5.Lines.Add(s);
        end;
      CloseFile(F);
      MemoDraw(Kadr);
      Form1.ScrollBar1.Max:=Kadr;
      Form1.ScrollBar1.Position:=Kadr;
      Kadr:=Kadr+1;
      Form1.Edit1.Text:=' : '+FileNam(Form1.OpenDialog1.FileName) ;
      Form3.Hide;
      end
    else Form1.Edit1.Text:='   ';
  end;
end;

procedure Save;
var
  F: TextFile;
  i,n: Integer;
  S:String;
begin
  Stop:=True;
  repeat
    Application.ProcessMessages;
    Sleep(100);
  until Form1.Timer1.Enabled=False;
  if Form1.SaveDialog1.Execute then
  begin
    if Form1.SaveDialog1.FilterIndex=1 then
      begin
      Form1.SaveDialog1.DefaultExt:='.ctr';
      AssignFile(F, Form1.SaveDialog1.FileName);
      Rewrite(F);
      Writeln(F, 'File for CarTester 1.0.0.2');
      Writeln(F, IntToStr(Kadr-1));
      for n:=1 to Kadr-1 do
        begin
        for i:=1 to 10 do
          Writeln(F, Data[n,i]);
        for i:=1 to 13 do
          if Data2[n,i] then Writeln(F, '1')
            else Writeln(F, '0');
        for i:=0 to 7 do
          if Flagi1[n,i] then Writeln(F, '1')
            else Writeln(F, '0');
        for i:=0 to 7 do
          if Flagi2[n,i] then Writeln(F, '1')
            else Writeln(F, '0');
        if Nechto[n] then Writeln(F, '1')
            else Writeln(F, '0');
        Writeln(F, TimeToStr(TimeN[n]));
        end;
      For i:=0 to 24 do
        begin
        Writeln(F,Form1.Memo3.Lines[i]);
        Writeln(F,Form1.Memo4.Lines[i]);
        Writeln(F,Form1.Memo5.Lines[i]);
        end;
      Form1.Edit1.Text:=' : '+FileNam(Form1.SaveDialog1.FileName) ;
      CloseFile(F);
    end;
    if Form1.SaveDialog1.FilterIndex=2 then
      begin
      Form1.SaveDialog1.DefaultExt:='.csv';
      AssignFile(F, Form1.SaveDialog1.FileName);
      Rewrite(F);
      Writeln(F, '  CarTester;;;;;;'+IntToStr(Kadr-1)+' ');
      Writeln(F, ';1:A;2:A;3:A;4:A;5:A;6:A;7:A;8:A;9:A;10:A;;11:0;11:1;11:2;11:3;11:4;11:5;11:6;11:7;12:0;12:1;12:2;12:3;12:4;12:5;12:6;12:7;;');
      for n:=1 to Kadr-1 do
        begin
        S:=IntToStr(n)+';';
        for i:=1 to 10 do
          S:=S+IntToStr(Data[n,i])+';';
        for i:=1 to 13 do
          if Data2[n,i] then S:=S+'1'
            else S:=S+'0';
        s:=s+';';
        for i:=0 to 7 do
          if Flagi1[n,i] then S:=S+'1;'
            else S:=S+'0;';
        for i:=0 to 7 do
          if Flagi2[n,i] then S:=S+'1;'
            else S:=S+'0;';
        if Nechto[n] then S:=S+'1;'
            else S:=S+'0;';
        S:=S+TimeToStr(TimeN[n]);
        WriteLn(F,S);
        end;
      WriteLn(F,'');
      S:=' ;';
      for i:= 0 to 24 do
        begin
        S:=S+Form1.Memo3.Lines[i]+';';
        end;
      WriteLn(F,S);
      S:=';';
      for i:= 0 to 24 do
        begin
        S:=S+Form1.Memo4.Lines[i]+';';
        end;
      WriteLn(F,S);
      S:=';';
      for i:= 0 to 24 do
        begin
        S:=S+Form1.Memo5.Lines[i]+';';
        end;
      WriteLn(F,S);
      Form1.Edit1.Text:=' : '+FileNam(Form1.SaveDialog1.FileName) ;
      CloseFile(F);
      end;
    end;
end;

procedure TForm1.TxRxrmCreate(Sender: TObject);
var
i:Byte;
begin
  for i:=1 to 20 do
    if AccessCOM(PChar('COM'+IntToStr(i))) then Form1.ComboBox1.Items.Add(PChar('COM'+IntToStr(i)));
  Kadr:=1;
  Davl:=False;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if Form1.ScrollBar1.Position>2 then
     if (data[Form1.ScrollBar1.Position,4]=0) and (data[Form1.ScrollBar1.Position-1,4]=0) then
        Memo3.Text:=Memo2.Text
     else ShowMessage('   !')
  else ShowMessage('    3 !');
end;

procedure TForm1.Button1Click(Sender: TObject);
var Mytr:Thread;
begin
  if Form1.Button1.Caption='' then
    begin
    Kadr:=1;
    Mytr:=Thread.Create(True);
    Mytr.Priority:=tpTimeCritical;
    Mytr.Resume;
    Form1.Button1.Caption:='';
    end
  else
    begin
    Stop:=True;
    Form1.Button1.Caption:='';
    end;
end;


procedure TForm1.Timer1Timer(Sender: TObject);
var
i:Integer;
begin
for i:=1 to 10 do
  data[kadr,i]:=Res(i);
for i:=1 to 13 do
  data2[kadr,i]:=fb1[i];
for i:= 0 to 7 do
  if da1[11,i] then flagi1[kadr,i]:=True
    else flagi1[kadr,i]:=False;
for i:= 0 to 7 do
  if da1[12,i] then flagi2[kadr,i]:=True
    else flagi2[kadr,i]:=False;
TimeN[kadr]:=Now;
MemoDraw(Kadr);
Form1.ScrollBar1.Max:=Kadr;
Form1.ScrollBar1.Position:=Kadr;
Kadr:=Kadr+1;
Timer1.Enabled:=False;
if Kadr>2000 then
  begin
  Save;
  end;
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
var
n:Integer;
begin
  n:=Form1.ScrollBar1.Position;
  MemoDraw(n);
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  Form1.Memo3.Clear;
end;

procedure TForm1.N4Click(Sender: TObject);
begin
  Form1.Close;
end;

procedure TForm1.N2Click(Sender: TObject);
begin
  Load;
end;

procedure TForm1.N3Click(Sender: TObject);
begin
  Save;
end;

procedure TForm1.N9Click(Sender: TObject);
begin
  Stop:=True;
  Form4.Show;
end;



procedure TForm1.N8Click(Sender: TObject);
begin
  Stop:=True;
  Form3.Show;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  if Form1.ScrollBar1.Position>2 then
     if (flagi2[Form1.ScrollBar1.Position,1]=True) and (flagi2[Form1.ScrollBar1.Position-1,1]=True) then
        if (data[Form1.ScrollBar1.Position,6]>227) and (data[Form1.ScrollBar1.Position-1,6]>227) then
          Memo4.Text:=Memo2.Text
        else ShowMessage('   !')
     else ShowMessage('     !')
  else ShowMessage('    3 !');
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  if Form1.ScrollBar1.Position>2 then
     if ((data[Form1.ScrollBar1.Position,4]+data[Form1.ScrollBar1.Position+1,4])>176) and ((data[Form1.ScrollBar1.Position,4]+data[Form1.ScrollBar1.Position+1,4])<200) then
        if (data[Form1.ScrollBar1.Position,6]>227) and (data[Form1.ScrollBar1.Position-1,6]>227) then
          Memo5.Text:=Memo2.Text
        else ShowMessage('   !')
     else ShowMessage('    2200-2500 ./.!')
  else ShowMessage('    3 !');
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  Form1.Memo4.Clear;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  Form1.Memo5.Clear;
end;

procedure TForm1.N11Click(Sender: TObject);
begin
  Stop:=True;
  Davl:=True;
  Form3.ComboBox1.Items.Delete(4);
  Form3.ComboBox2.Items.Delete(4);
  Form3.ComboBox3.Items.Delete(4);
  Form3.ComboBox1.Items.Insert(4,' .   ..');
  Form3.ComboBox2.Items.Insert(4,' .   ..');
  Form3.ComboBox3.Items.Insert(4,' .   ..');
  MemoDraw(Form1.ScrollBar1.Position);
end;

procedure TForm1.N10Click(Sender: TObject);
begin
  Stop:=True;
  Davl:=False;
  Form3.ComboBox1.Items.Delete(4);
  Form3.ComboBox2.Items.Delete(4);
  Form3.ComboBox3.Items.Delete(4);
  Form3.ComboBox1.Items.Insert(4,' .   ');
  Form3.ComboBox2.Items.Insert(4,' .   ');
  Form3.ComboBox3.Items.Insert(4,' .   ');
  MemoDraw(Form1.ScrollBar1.Position);
end;

end.
